var express = require('express');
var router = express.Router();
const Powerwall = require('../powerwall')

const powerwall  = new Powerwall('192.168.x.x', 'STGXXXXXXXXX')

const backupReserve = 30

let touOn = false
let ohmHourOn = false

router.get('/', function(req, res, next) {
  return powerwall.getOperation().then((response) => {
    res.send(response)
    powerwall.commitOperation()
  }).catch((error) => {
    res.send(`${error.response.status}: ${JSON.stringify(error.response.data, null, '  ')}`)
  })
});

function _setBackupReserve (reservePercent, res, mode='self_consumption') {
  return powerwall.setOperation(reservePercent, mode).then((response) => {
    res.send(response)
    powerwall.commitOperation()
  }).catch((error) => {
    res.send(`${error.response.status}: ${JSON.stringify(error.response.data, null, '  ')}`)
  })
}

router.get('/on', function(req, res, next) {
  return _setBackupReserve(backupReserve, res)
})

router.get('/off', function(req, res, next) {
  return _setBackupReserve(100, res)
})

router.get('/touOn', function(req, res, next) {
  touOn = true
  return _setBackupReserve(backupReserve, res)
})

router.get('/touOff', function(req, res, next) {
  touOn = false
  if (ohmHourOn) {
    res.send({ohmHourOn: true})
  } else return _setBackupReserve(100, res)
})

router.get('/ohmHourOn', function(req, res, next) {
  ohmHourOn = true
  return _setBackupReserve(backupReserve, res)
})

router.get('/ohmHourOff', function(req, res, next) {
  ohmHourOn = false
  if (touOn) {
    res.send({touOn: true})
  } else return _setBackupReserve(100, res)
})


module.exports = router;
